import bpy
from bpy.types import Menu

class PIE_MT_UnwrapOptions(Menu):
    bl_idname = "PIE_MT_UnwrapOptions"
    bl_label = "Unwrap Setting"
    def draw_header(self):
        layout = self.layout
        layout.label(text="", icon='PREFERENCES')

    def draw(self, context):
        C = bpy.context
        scene = context.scene
        easeam_prop = scene.UVsProps
        layout = self.layout
        
        # row = layout.row()
        # row.prop(easeam_prop, "u_method", expand= True)
        row = layout.row(align= True)
        row.prop(easeam_prop, "fl_hol")
        row = layout.row(align= True)
        row.prop(easeam_prop, "cr_aspect")
        row = layout.row(align= True)
        row.prop(easeam_prop, "us_subf")
        row = layout.row(align= True)
        row.prop(easeam_prop, "mrgn")
class easeam_pie():
    def smartseam(self):
        layout = self.layout
        pie = layout.menu_pie()

        col= pie.column(align = True)
        col.scale_y= 1.2
        col.operator('mesh.sharpseam', text="Seam by Sharp Edge")
        col.operator('mesh.smartseam', text="Auto Unwrap & Seam", icon= 'SHADERFX')
        # col.operator("object.autoseamtube") #TODO
        # col= col.column(align= True)
        # col.popover('OCV_PT_AutoUnwrap', text='', icon='DRIVER_ROTATIONAL_DIFFERENCE', icon_value=1)

    def reunwrap(self):
        layout = self.layout
        pie = layout.menu_pie()


class VIEW3D_MT_PIE_Easeam(Menu):
    bl_label = "Easeam"

    def draw(self, context):
        C = bpy.context

        scene = context.scene
        easeam_prop = scene.UVsProps
        layout = self.layout
        pie = layout.menu_pie()

        if not C.object.data.uv_layers:
            col = pie.column()
            col.label(text="Object has no UV-Map", icon= 'ERROR')
            op = col.operator('uv.add_new_uv_layer', text="Add UV-Map")
            op.obj_name = C.object.name
            op.batch = False

            return

        row= pie.row(align= True)
        row.scale_y= 1.2
        row.prop(easeam_prop, "s_loop", icon= 'EVENT_S', icon_only= True)
        row.operator('mesh.limitloop', text="Seam Edge Loop")
        row.prop(easeam_prop, "u_loop_seam", icon= 'EVENT_U', icon_only= True)

        row= pie.row(align= True)
        row.scale_y= 1.2
        row.operator('mesh.cylindercut', text="Tube Seam")
        row.prop(easeam_prop, "u_tube", icon= 'EVENT_U', icon_only= True)

        
        row= pie.row(align= True)
        # scene.tool_settings.use_edge_path_live_unwrap
        row.prop(scene.tool_settings, "use_edge_path_live_unwrap", text= '', icon= 'EVENT_L')
        row.prop(easeam_prop, "u_method", expand= True)

        row= row.column(align= True)
        row.menu("PIE_MT_UnwrapOptions", text="", icon='PREFERENCES')


        row= pie.row(align= True)
        row.scale_y= 1.2
        row.prop(easeam_prop, "alws_hide", icon= 'EVENT_H', icon_only= True)
        row.operator('mesh.boundaryseam', text="Mark Around Flat")
        row.prop(easeam_prop, "u_mark_around_flat", icon= 'EVENT_U', icon_only= True)
        
        row= pie.row(align= True)
        row.scale_y= 1.2
        row.operator('mesh.easeamclearseam', text="Clear Seam")

        row= pie.row(align= True)
        row.scale_y= 1.2
        row.operator('mesh.easeammarkseam', text="Mark Seam")

        grid= pie.grid_flow(columns = 2, align= True)
        grid.scale_y= 1.2
        grid.operator('mesh.reunwrap', text="Re-Unwrap", icon= 'FILE_REFRESH')

        grid.row().operator('mesh.hideisland', text="Hide Island", icon= 'HIDE_ON')
        
        easeam_pie.smartseam(self)

